models/Contest.php
<?php

namespace app\models;

use app\common\behaviors\NestedValuesBehavior;
use Yii;
use yii\base\UnknownPropertyException;
use yii\db\ActiveRecord;
use yii\helpers\ArrayHelper;

/**
 * This is the model class for table "contests".
 *
 * @property integer        $id
 * @property integer        $contest_type_id
 * @property integer        $generation_type_id
 * @property string         $substrate
 * @property string         $substrate_thumb
 * @property string         $substrate_back
 * @property string         $textBefore1
 * @property string         $textBefore2
 * @property string         $textBefore3
 * @property string         $textAfter1
 * @property string         $textAfter2
 * @property string         $textAfter3
 * @property string         $codeName
 * @property string         $name
 * @property integer        $number
 * @property string         $substrateFile
 * @property bool           $deleteSubstrate
 * @property integer        $stage
 * @property integer        $base_for_stage
 *
 * @property string         $nestedSubstrate
 * @property string         $nestedSubstrateThumb
 * @property string         $nestedSubstrateBack
 * @property string         $nestedTextBefore1
 * @property string         $nestedTextBefore2
 * @property string         $nestedTextBefore3
 * @property string         $nestedTextAfter1
 * @property string         $nestedTextAfter2
 * @property string         $nestedTextAfter3
 * @property string         $nestedGeneration_type_id
 * @property integer        $substrate_type
 * @property string         $substrateTypeText
 *
 * @property ContestType    $contestType
 * @property GenerationType $generationType
 * @property Honor[]        $honors
 */
class Contest extends ActiveRecord
{
    const TYPE_IMAGE = 1;
    const TYPE_PLANE = 2;
    const TYPE_CENTER_IMAGE = 3;

    public $substrateFile;
    public $deleteSubstrate;

    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'contests';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [
                [
                    'clearTextAfter1',
                    'clearTextAfter2',
                    'clearTextAfter3',
                    'clearTextBefore1',
                    'clearTextBefore2',
                    'clearTextBefore3'
                ],
                'safe'
            ],
            [['substrateFile', 'deleteSubstrate'], 'safe'],
            [['name', 'contest_type_id'], 'required'],
            [['name', 'codeName', 'number'], 'unique'],
            [['contest_type_id','base_for_stage', 'substrate_type', 'generation_type_id'], 'integer'],
            [['substrate', 'substrate_thumb', 'substrate_back',], 'string', 'max' => 255],
            [['textBefore1', 'textBefore2', 'textBefore3', 'textAfter1', 'textAfter2', 'textAfter3'], 'string'],
            [['name'], 'string', 'max' => 255],
            [['contest_type_id'], 'exist', 'skipOnError' => true, 'targetClass' => ContestType::className(), 'targetAttribute' => ['contest_type_id' => 'id']],
        ];
    }

    public function behaviors()
    {
        return [
            'nestedValues' => [
                'class'        => NestedValuesBehavior::className(),
                'nestedSuffix' => null,
                'nestProperty' => 'contestType',
                'nestedFields' => [
                    'substrateBack'  => [
                        'property' => 'substrate_back',
                    ],
                    'substrateThumb' => [
                        'property' => 'substrate_thumb',
                    ],
                    'generation_type_id',
                    'substrate',
                    'textAfter1',
                    'textAfter2',
                    'textAfter3',
                    'textBefore1',
                    'textBefore2',
                    'textBefore3'
                ]
            ]
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id'              => 'ID',
            'contest_type_id' => 'Тип конкурса',
            'substrate'       => 'Обложка',
            'deleteSubstrate' => 'Сбросить обложку',
            'substrateFile'   => 'Обложка',
            'stage'           => 'Этап',
            'category'        => 'Категория конкурса',
            'textBefore1'     => 'Текст до 1',
            'textBefore2'     => 'Текст до 2',
            'textBefore3'     => 'Текст до 3',
            'textAfter1'      => 'Текст после 1',
            'textAfter2'      => 'Текст после 2',
            'textAfter3'      => 'Текст после 3',
            'name'            => 'Название',
            'codeName'        => 'Кодовое название',
            'number'          => 'Номер конкурса',
            'base_for_stage'  => 'Грамоты для этапа',

            'substrate_type'  => 'Тип подложки',
            'substrateTypeText'  => 'Тип подложки',
            'generation_type_id' => 'Тип генерации',

            'nestedTextBefore1' => 'Текст до 1',
            'nestedTextBefore2' => 'Текст до 2',
            'nestedTextBefore3' => 'Текст до 3',
            'nestedTextAfter1'  => 'Текст после 1',
            'nestedTextAfter2'  => 'Текст после 2',
            'nestedTextAfter3'  => 'Текст после 3',
            'clearTextBefore1'  => 'Очистить текст до 1',
            'clearTextBefore2'  => 'Очистить текст до 2',
            'clearTextBefore3'  => 'Очистить текст до 3',
            'clearTextAfter1'   => 'Очистить текст после 1',
            'clearTextAfter2'   => 'Очистить текст после 2',
            'clearTextAfter3'   => 'Очистить текст после 3',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getContestType()
    {
        return $this->hasOne(ContestType::className(), ['id' => 'contest_type_id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getHonors()
    {
        return $this->hasMany(Honor::className(), ['contest_id' => 'id']);
    }

    public function getStage()
    {
        return $this->contestType->contestCategory->stage;
    }

    public function getGenerationType()
    {
        return GenerationType::findOne($this->nestedGeneration_type_id);
    }

    public static function findByString($string)
    {
        return self::find()
            ->andWhere(['like', 'name', $string])
            ->all();
    }

    /**
     * @return array
     */
    public static function findByNumber($number)
    {
        return self::find()
            ->andFilterWhere(['number' => $number])
            ->one();
    }

    public static function findBaseForStage($stage)
    {
        static::find()
            ->andWhere(['base_for_stage' => $stage])
            ->one();
    }

    public static function getSubstrateTypeTexts()
    {
        return [
            static::TYPE_IMAGE => 'Тип с потенциальной картинкой',
            static::TYPE_PLANE => 'Тип во всю страницу',
            static::TYPE_CENTER_IMAGE => 'Картинка по центру'
        ];
    }

    public function getSubstrateTypeText()
    {
        return ArrayHelper::getValue(static::getSubstrateTypeTexts(), $this->substrate_type, null);
    }

    public function beforeSave($insert)
    {
        $substrateType = $this->substrate_type;
        if($insert && empty($substrateType)){
            $this->substrate_type = Contest::TYPE_PLANE;
        }

        return parent::beforeSave($insert);
    }

    public function recalculateHonors()
    {
        foreach ($this->honors as $honor) {
            $honor->recalculate();
        }
    }
}

controllers/ContestController.php
<?php

namespace app\controllers;

use app\models\ContestType;
use app\models\GenerationType;
use app\models\search\ContestSearch;
use app\models\UploadFile;
//use Imagine\Image\Box;
use Yii;
use app\models\Contest;
//use yii\imagine\Image;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\web\Response;
use yii\web\UploadedFile;

/**
 * ContestController implements the CRUD actions for Contest model.
 */
class ContestController extends Controller
{

    use TraitExportImportable;
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    public function beforeAction($action)
    {
        if(!Yii::$app->user->can('gramPermission')){
            return $this->redirect(['site/login'], 302);
        }

        return parent::beforeAction($action);
    }


    /**
     * Lists all Contest models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new ContestSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
            'uploadForm' => $this->trySaveFile(UploadFile::TYPE_CONTEST),
            'downloadForm' => $this->tryStartGenerate(UploadFile::TYPE_CONTEST)
        ]);
    }

    /**
     * Displays a single Contest model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Contest model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Contest();

        $contestTypes = ContestType::getContestTypes();
        $generationTypes = GenerationType::getGenerationTypes();
        $substrateTypes = Contest::getSubstrateTypeTexts();

        if(!$model->load(Yii::$app->request->post())){
            return $this->render('create', [
                'model' => $model,
                'contestTypes' => $contestTypes,
                'generationTypes' => $generationTypes,
                'substrateTypes' => $substrateTypes
            ]);
        }

        $uploadedSubstrate = UploadedFile::getInstance($model, 'substrateFile');

        //needed id for generate path for substrate
        if(!$model->save()){
            return $this->render('create', [
                'model' => $model,
                'contestTypes' => $contestTypes,
                'generationTypes' => $generationTypes,
                'substrateTypes' => $substrateTypes
            ]);
        }

        if(!empty($uploadedSubstrate)){
            $extension     = pathinfo($uploadedSubstrate->name, PATHINFO_EXTENSION);
            $substrateFile = Yii::getAlias("@substrateBase/contest_{$model->id}." . $extension);
            $fullPath = Yii::getAlias("@app/$substrateFile");
            move_uploaded_file($uploadedSubstrate->tempName, $fullPath);

//            $image=new \Imagick($uploadedSubstrate->tempName);
//            $image->setImageFormat('png');
//            $image->writeImage($fullPath);
//            chmod($fullPath, 0777);
//
//            $substrateBackGroundFile = Yii::getAlias("@substrateBase/contest_{$model->id}_b.png");
//            $fullPathBackGround = Yii::getAlias("@app/$substrateBackGroundFile");
//
//            $image=new \Imagick($uploadedSubstrate->tempName);
//            $image->setImageOpacity(0.5);
//            $image->writeImage($fullPathBackGround);
//            chmod($fullPathBackGround, 0777);
//
//            $thumbnail = Yii::getAlias("@substrateBase/contest_{$model->id}_t." . $extension);
//            $fullPathThumbnail = Yii::getAlias("@app/$thumbnail");
//
//            Image::frame($fullPath)
//                ->thumbnail(new Box(200, 200))
//                ->save($fullPathThumbnail, ['quality' => 80]);
//            chmod($fullPathThumbnail, 0777);

            $model->substrate_back = $substrateFile;
            $model->substrate_thumb = $substrateFile;
            $model->substrate = $substrateFile;

            if(!$model->save()){
                return $this->render('create', [
                    'model' => $model,
                    'contestTypes' => $contestTypes,
                    'generationTypes' => $generationTypes,
                    'substrateTypes' => $substrateTypes
                ]);
            }
        }

        return $this->redirect(['view', 'id' => $model->id]);
    }

    /**
     * Updates an existing Contest model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        $contestTypes = ContestType::getContestTypes();
        $generationTypes = GenerationType::getGenerationTypes();
        $substrateTypes = Contest::getSubstrateTypeTexts();

        if(empty($model)){
            return $this->render('create', [
                'model' => $model,
                'contestTypes' => $contestTypes,
                'generationTypes' => $generationTypes,
                'substrateTypes' => $substrateTypes
            ]);
        }

        if(!$model->load(Yii::$app->request->post())){
            return $this->render('update', [
                'model' => $model,
                'contestTypes' => $contestTypes,
                'generationTypes' => $generationTypes,
                'substrateTypes' => $substrateTypes
            ]);
        }

        $uploadedSubstrate = UploadedFile::getInstance($model, 'substrateFile');

        if (!empty($uploadedSubstrate)) {
            $extension     = pathinfo($uploadedSubstrate->name, PATHINFO_EXTENSION);
            $substrateFile = Yii::getAlias("@substrateBase/contest_{$model->id}." . $extension);
            $fullPath = Yii::getAlias("@app/$substrateFile");
            move_uploaded_file($uploadedSubstrate->tempName, $fullPath);

//            $image=new \Imagick($uploadedSubstrate->tempName);
//            $image->setImageFormat('png');
//            $image->writeImage($fullPath);
//
//            $substrateBackGroundFile = Yii::getAlias("@substrateBase/contest_{$model->id}_b.png");
//            $fullPathBackGround = Yii::getAlias("@app/$substrateBackGroundFile");
//
//            $image=new \Imagick($uploadedSubstrate->tempName);
//            $uploadedSubstrate->tempName;
//            $image->setImageOpacity(0.5);
//            $image->writeImage($fullPathBackGround);
//
//            $thumbnail = Yii::getAlias("@substrateBase/contest_{$model->id}_t." . $extension);
//            $fullPathThumbnail = Yii::getAlias("@app/$thumbnail");
//
//            Image::frame($fullPath)
//                ->thumbnail(new Box(200, 200))
//                ->save($fullPathThumbnail, ['quality' => 80]);

            $model->substrate_back = $substrateFile;
            $model->substrate_thumb = $substrateFile;
            $model->substrate = $substrateFile;
        }

        if(!empty($model->deleteSubstrate)){
            $model->substrate_back = null;
            $model->substrate_thumb = null;
            $model->substrate = null;
        }

        if (!$model->save()) {
            return $this->render('update', [
                'model' => $model,
                'contestTypes' => $contestTypes,
                'generationTypes' => $generationTypes,
                'substrateTypes' => $substrateTypes
            ]);
        }

        return $this->redirect(['view', 'id' => $model->id]);
    }

    /**
     * Deletes an existing Contest model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Contest model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Contest the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Contest::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }

    public function actionList($q = null, $id = null) {
        \Yii::$app->response->format = Response::FORMAT_JSON;

        $out = ['results' => ['id' => '', 'text' => '']];

        if (!is_null($q)) {
            $out['results'] = [];

            $contests = Contest::findByString($q);

            foreach ($contests as $contest) {
                $out['results'][] = ['id' => $contest->id, 'text' => $contest->name];
            }
        }
        elseif ($id > 0) {
            $contest = $this->findModel($id);
            $out['results'] = ['id' => $id, 'text' => $contest->name];
        }

        return $out;
    }
}

views/contest/_form.php
<?php

use app\models\People;
use kartik\form\ActiveForm;
use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Contest */
/* @var $contestTypes array */
/* @var $generationTypes array */
/* @var $substrateTypes array */
/* @var $form yii\widgets\ActiveForm */

$this->params['imagePath'] = $model->nestedSubstrateBack;
?>

<div class="contest-form">

    <?php $form = ActiveForm::begin([
        'options' => ['enctype' => 'multipart/form-data'],
        'method' => 'post']); ?>

    <?= $form->field($model, 'substrateFile')->fileInput() ?>

    <?php if(!$model->isNewRecord):?>
        <?= $form->field($model, 'deleteSubstrate')->checkbox() ?>
    <?php endif;?>

    <?= $form->field($model, 'name')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'codeName')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'number')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'base_for_stage')->textInput() ?>

    <?= $form->field($model, 'contest_type_id')->dropDownList($contestTypes) ?>

    <?= $form->field($model, 'substrate_type')->dropDownList($substrateTypes) ?>

    <?= $form->field($model, 'generation_type_id')->dropDownList($generationTypes, ['prompt' => 'Наследовать от типа']) ?>

    <?= $form->field($model, 'textBefore1')->textInput(['maxlength' => true]) ?>
    <?php if(!$model->isNewRecord):?>
        <?= $form->field($model, 'clearTextBefore1')->checkbox() ?>
    <?php endif;?>

    <?= $form->field($model, 'textBefore2')->textInput(['maxlength' => true]) ?>
    <?php if(!$model->isNewRecord):?>
        <?= $form->field($model, 'clearTextBefore2')->checkbox() ?>
    <?php endif;?>

    <?= $form->field($model, 'textBefore3')->textInput(['maxlength' => true]) ?>
    <?php if(!$model->isNewRecord):?>
        <?= $form->field($model, 'clearTextBefore3')->checkbox() ?>
    <?php endif;?>

    <?= $form->field($model, 'textAfter1')->textInput(['maxlength' => true]) ?>
    <?php if(!$model->isNewRecord):?>
        <?= $form->field($model, 'clearTextAfter1')->checkbox() ?>
    <?php endif;?>

    <?= $form->field($model, 'textAfter2')->textInput(['maxlength' => true]) ?>
    <?php if(!$model->isNewRecord):?>
        <?= $form->field($model, 'clearTextAfter2')->checkbox() ?>
    <?php endif;?>

    <?= $form->field($model, 'textAfter3')->textInput(['maxlength' => true]) ?>
    <?php if(!$model->isNewRecord):?>
        <?= $form->field($model, 'clearTextAfter3')->checkbox() ?>
    <?php endif;?>

    <div class="form-group">
        <?= Html::submitButton($model->isNewRecord ? 'Создать' : 'Обновить', ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/contest/_index.php
<?php

use app\models\ContestType;
use kartik\select2\Select2;
use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider \app\models\search\ContestSearch */
/* @var $searchModel yii\data\ActiveDataProvider */

$this->title = 'Конкурсы';
?>
<div class="contest-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Добавить конкурс', ['create'], ['class' => 'btn btn-success']) ?>
    </p>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'id',
            [
                'attribute' => 'name',
                'format' => 'raw',
                'value' => function($model){
                    return Html::a($model->name, ['/contest/view', 'id' => $model->id]);
                },
            ],
            'codeName',
            'number',
            [
                'attribute' => 'contest_type_id',
                'format' => 'raw',
                'value' => function($model){
                    return Html::a($model->contestType->name, ['/contest-type/view', 'id' => $model->contest_type_id]);
                },
                'filter' => Select2::widget([
                    'model' => $searchModel,
                    'data' => ContestType::getContestTypes(),
                    'attribute' => 'contest_type_id',
                    'options' => [
                        'placeholder' => 'Выбор типа',
                    ],
                    'pluginOptions' => [
                        'allowClear' => true,
                    ]
                ])
            ],
            [
                'attribute' => 'category',
                'format' => 'raw',
                'value' => function($model){
                    return Html::a($model->contestType->contestCategory->name, ['/contest-category/view', 'id' => $model->contestType->contest_category_id]);
                },
                'filter' => Select2::widget([
                    'model' => $searchModel,
                    'data' => \app\models\ContestCategory::getContestCategories(),
                    'attribute' => 'category',
                    'options' => [
                        'placeholder' => 'Выбор категории',
                        'allowClear' => true,
                    ],
                    'pluginOptions' => [
                        'allowClear' => true,
                    ]
                ])
            ],
//            [
//                'attribute' => 'substrate',
//                'format' => 'html',
//                'value' => function($data)
//                {
//                    if(!empty($data->nestedSubstrateThumb) && file_exists(Yii::getAlias("@app/{$data->nestedSubstrateThumb}"))){
//                        return Html::img(Yii::$app->request->baseUrl . '/' . $data->nestedSubstrateThumb);
//                    }
//
//                    return null;
//                },
//            ],
            'stage',
            [
                'attribute' => 'generation_type_id',
                'value' => function($model){
                    return $model->generationType->name;
                }
            ],
            'nestedTextBefore1',
            'nestedTextBefore2',
            'nestedTextBefore3',
            'nestedTextAfter1',
            'nestedTextAfter2',
            'nestedTextAfter3',
            'base_for_stage',
            'substrateTypeText',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>

</div>

views/contest/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model app\models\Contest */
/* @var $contestTypes array */
/* @var $generationTypes array */
/* @var $substrateTypes array */

$this->title = 'Добавление конкурса';
$this->params['breadcrumbs'][] = ['label' => 'Конкурсы', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="contest-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
        'contestTypes' => $contestTypes,
        'generationTypes' => $generationTypes,
        'substrateTypes' => $substrateTypes
    ]) ?>

</div>

views/contest/index.php
<?php

use app\models\ContestType;
use kartik\select2\Select2;
use kartik\tabs\TabsX;
use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider \app\models\search\ContestSearch */
/* @var $searchModel yii\data\ActiveDataProvider */
/* @var $uploadForm */
/* @var $downloadForm */

$this->title = 'Конкурсы';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="contest-index">


    <?php $tabs[] = [
        'label'=>'<i class="glyphicon glyphicon-info-sign"></i> Конкурсы',
        'content'=> $this->render('_index', [
                'dataProvider' => $dataProvider,
                'searchModel' => $searchModel
            ]),
        'active'=>true,
    ];?>

    <?php $tabs[] = [
        'label'=>'<i class="glyphicon glyphicon-info-sign"></i> Импорт',
        'content'=> $uploadForm,
    ];?>

    <?php $tabs[] = [
        'label'=>'<i class="glyphicon glyphicon-info-sign"></i> Экспорт',
        'content'=> $downloadForm,
    ];?>

    <?= TabsX::widget([
        'items'=> $tabs,
        'position'=>TabsX::POS_ABOVE,
        'encodeLabels'=>false
    ]);?>

</div>

views/contest/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $contestTypes array */
/* @var $generationTypes array */
/* @var $substrateTypes array */
/* @var $model app\models\Contest */

$this->title = 'Обновление конкурса: ' . $model->name;
$this->params['breadcrumbs'][] = ['label' => 'Конкурсы', 'url' => ['/contest/index']];
$this->params['breadcrumbs'][] = [
    'label' => 'Категория: ' . $model->contestType->contestCategory->name,
    'url' => ['/contest-category/view', 'id' => $model->contestType->contest_category_id]];
$this->params['breadcrumbs'][] = [
    'label' => 'Тип: ' . $model->contestType->name ,
    'url' => ['/contest-type/view', 'id' => $model->contest_type_id]];
$this->params['breadcrumbs'][] = [
    'label' => 'Конкурс: ' . $model->name,
    'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = 'Обновление';
?>
<div class="contest-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
        'contestTypes' => $contestTypes,
        'generationTypes' => $generationTypes,
        'substrateTypes' => $substrateTypes
    ]) ?>

</div>

views/contest/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Contest */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => 'Конкурсы', 'url' => ['/contest/index']];
$this->params['breadcrumbs'][] = [
    'label' => 'Категория: ' . $model->contestType->contestCategory->name,
    'url' => ['/contest-category/view', 'id' => $model->contestType->contest_category_id]];
$this->params['breadcrumbs'][] = [
    'label' => 'Тип: ' . $model->contestType->name ,
    'url' => ['/contest-type/view', 'id' => $model->contest_type_id]];
$this->params['breadcrumbs'][] = $this->title;

$this->params['imagePath'] = $model->nestedSubstrateBack;
?>
<div class="contest-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Обновить', ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Удалить', ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Вы уверены, что вы хотите удалить конкурс?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <p>
        <?= Html::a('Выдать награду', ['honor/create','contestId' => $model->id], ['class' => 'btn btn-success']) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'name',
            'codeName',
            'number',
            [
                'attribute' => 'contest_type_id',
                'value' => $model->contestType->name,
            ],
            [
                'attribute' => 'generation_type_id',
                'value' => $model->generationType->name
            ],
            'nestedTextBefore1',
            'nestedTextBefore2',
            'nestedTextBefore3',
            'nestedTextAfter1',
            'nestedTextAfter2',
            'nestedTextAfter3',
            'base_for_stage',
            'substrateTypeText',
        ],
    ]) ?>

</div>